#include <iostream>
#include <cmath>

using namespace std;

// Konstruktoren und Destruktoren sind optional.
struct Point
{
  int x, y;
  double length()
  {
    return sqrt(x * x + y * y);
  }
};

class Rectangle
{
public:
  // Konstruktor
  Rectangle(int x_, int y_, int width_, int height_)
  {
    width = width_;
    height = height_;
    
    position = new Point();
    position->x = x_;
    position->y = y_;
  }
  

  // Destruktor
  ~Rectangle()
  {
    delete position;
  }

  int area()
  {
    return width * height;
  }
  
  // Die Funktion kann ausserhalb der Klasse implementiert werden.
  double distance();

private:
  int width, height;
  Point* position;
};

// Benutzen des ::-Operators (scope resolution),
// Wir implementieren die Funktion 'distance' der Klasse Rectangle.
double Rectangle::distance()
{
  return position->length();
}

int main()
{
  // Rechteck an Position (3,4) mit Breite 5 und Hoehe 6.
  Rectangle r = Rectangle(3, 4, 5, 6);

  cout << "Distanz: " << r.distance() << endl;
  cout << "Flaeche: " << r.area() << endl;
  
  return 0;
}
