#include <iostream>
#include <queue>
#include <set>
#include <map>
#include <string>
using namespace std;

struct Coordinate
{
  int x, y;
  Coordinate(int x_, int y_)
  {
    x = x_; y = y_;
  }

  // Ueberladen des Vergleichsoperators.
  // Vergleiche x-Werte und benutze y-Werte bei identischen x-Werten.
  bool operator<(const Coordinate& other) const
  {
    return (x < other.x) ||
           (x == other.x && y < other.y); 
  }
};

int main()
{
  // Ein Heap von Koordinaten.
  priority_queue<Coordinate> pq;
  pq.push(Coordinate(1,2));
  pq.push(Coordinate(3,4));
  pq.push(Coordinate(5,6));

  // Die Koordinaten sortiert ausgeben (Maximum zuerst).
  while(!pq.empty())
  {
    cout << pq.top().x << "," << pq.top().y << endl;
    pq.pop();
  }

  // Set von ganzen Zahlen.
  set<int> s;
  s.insert(5);
  s.insert(4);
  s.insert(5);
  s.insert(4);
  cout << s.size() << endl; // Gibt aus: 2

  // Mapping von Koordinaten auf strings.
  map<Coordinate, string> m; 
  m[Coordinate(1,3)] = "Untere linke Ecke";
  m[Coordinate(5,5)] = "Obere rechte Ecke";

  // Vor dem Zugriff wird getestet, ob das Element existiert.
  Coordinate c(5,5);
  if(m.find(c) != m.end())
    cout << m[c] << endl;

  return 0;
}
